Module java.compiler
Package javax.tools

## Enum JavaFileObject.Kind

- java.lang.Object
- - java.lang.Enum<JavaFileObject.Kind>
  - - javax.tools.JavaFileObject.Kind

All Implemented Interfaces:
  `Serializable`, `Comparable<JavaFileObject.Kind>`

Enclosing interface:
  JavaFileObject

    public static enum JavaFileObject.Kind
    extends Enum<JavaFileObject.Kind>

Kinds of JavaFileObjects.

### Enum Constant Summary

Enum Constants
`CLASS` Class files for the Java Virtual Machine.
`HTML` HTML files.
`OTHER` Any other kind.
`SOURCE` Source files written in the Java programming language.

### Field Summary

Fields
`String` `extension` The extension which (by convention) is normally used for this kind of file object.

### Method Summary

All Methods Static Methods Concrete Methods
`static JavaFileObject.Kind` `valueOf​(String name)` Returns the enum constant of this type with the specified name.
`static JavaFileObject.Kind[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods declared in class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### SOURCE

    public static final JavaFileObject.Kind SOURCE

Source files written in the Java programming language. For example, regular files ending with `.java`.

#### CLASS

    public static final JavaFileObject.Kind CLASS

Class files for the Java Virtual Machine. For example, regular files ending with `.class`.

#### HTML

    public static final JavaFileObject.Kind HTML

HTML files. For example, regular files ending with `.html`.

#### OTHER

    public static final JavaFileObject.Kind OTHER

Any other kind.

### Field Detail

#### extension

    public final String extension

The extension which (by convention) is normally used for this kind of file object. If no convention exists, the empty string (`""`) is used.

### Method Detail

#### values

    public static JavaFileObject.Kind[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (JavaFileObject.Kind c : JavaFileObject.Kind.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static JavaFileObject.Kind valueOf​(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null